import laniopy
import laniopy.model

# インスタンスを生成します。
lanio = laniopy.Lanio()

while True:
    print('0 : disconnect')
    print('1 : connect')
    print('2 : getId')
    print('3 : getModel')
    print('4 : requestIdModel')
    print('5 : getAnalogInputAll')
    print('6 : getAnalogInputByValue')
    print('7 : getAnalogInputRange')
    print('8 : setAnalogOutputVoltage')
    print('9 : setAnalogOutputCurrent')

    try:
        num = int(input(' > '))
        if num == 0:
            # LANIO との通信を切断します。
            lanio.disconnect()
            break
        elif num == 1:
            address = input('address > ')
            port = int(input('port > '))
            timeout = float(input('timeout(sec) > '))
            # 接続先アドレス、ポート番号、タイムアウト時間を設定します。
            print(lanio.connect(address, port, timeout))
        elif num == 2:
            # LANIOのID情報を取得します。
            print(lanio.getId())
        elif num == 3:
            # LANIOのモデル情報を取得します。
            print(lanio.getModel())
        elif num == 4:
            # LANIOからモデル情報とID情報を取得します。
            devType, devId, model = lanio.requestIdModel()
            print(f'type : {devType}')
            print(f'id   : {devId}')
            print(f'model: {model}')
        elif num == 5:
            # LANIOのすべてのアナログ入力値をADC値で取得します。
            print(lanio.getAnalogInputAll())
        elif num == 6:
            aiNum = int(input('AI num > '))
            # LANIOのアナログ入力の現在値をレンジ設定とともに取得します。
            print(lanio.getAnalogInputByValue(aiNum))
        elif num == 7:
            aiNum = int(input('AI num > '))
            # LANIOのアナログ入力のレンジ設定を取得します。
            print(lanio.getAnalogInputRange(aiNum))
        elif num == 8:
            aoNum = int(input('AO num > '))
            voltage = float(input('Voltage(-10.0 ~ 10.0) [V] > '))
            # LANIOのアナログ出力の出力値を電圧値で指定して出力します。
            print(lanio.setAnalogOutputVoltage(aoNum, voltage))
        elif num == 9:
            aoNum = int(input('AO num > '))
            current = float(input('Current(0.0 ~ 20.0) [mA] > '))
            # LANIOのアナログ出力の出力値を電流値で指定して出力します。
            print(lanio.setAnalogOutputCurrent(aoNum, current))
    except (ValueError, laniopy.LanioError) as e:
        print(e.args)
