import laniopy as la
import tkinter as tk
import argparse
import sys
import functools
import time


def callbackBtn(lanio: la.Lanio, num: int, _):
    try:
        lanio.outPio(num, not lanio.getOut(num))
    except la.LanioError:
        # Error handling
        pass


def main(address, port):
    # Connect to LANIO
    lanio = la.Lanio()
    if not lanio.connect(address, port, 1):
        return

    if lanio.getDoNum() < 1:
        lanio.disconnect()
        return

    # tkinter
    root = tk.Tk()
    root.title('LANIO Example')

    for do in range(lanio.getDoNum()):
        b = tk.Button(text=f'DO{do+1}', width=4, height=2)
        b.bind('<Button-1>', functools.partial(callbackBtn, lanio, do))
        b.grid(row=2, column=do)

    root.mainloop()


if __name__ == '__main__':
    parser = argparse.ArgumentParser(
        prog=sys.argv[0], description='LANIO tkinter example'
    )
    parser.add_argument('-a', '--address', type=str, required=True)
    parser.add_argument('-p', '--port', type=int, required=True)
    args = parser.parse_args()
    main(args.address, args.port)
