import laniopy
import laniopy.model

# インスタンスを生成します。
lanio = laniopy.Lanio()
# 無線LANIOを使用する場合は、上記の代わりに下記で設定します。
# lanio = laniopy.Lanio(devtype=laniopy.model.LanioDeviceType.WIFI)

while True:
    print('0 : disconnect')
    print('1 : connect')
    print('2 : getId')
    print('3 : getModel')
    print('4 : getDoNum')
    print('5 : getDiNum')
    print('6 : requestIdModel')
    print('7 : outPio')
    print('8 : outPioAll')
    print('9 : inPio')
    print('10: inPioAll')
    print('11: getOut')
    print('12: getOutAll')

    try:
        num = int(input(' > '))
        if num == 0:
            # LANIO との通信を切断します。
            lanio.disconnect()
            break
        elif num == 1:
            address = input('address > ')
            port = int(input('port > '))
            timeout = float(input('timeout(sec) > '))
            # 接続先アドレス、ポート番号、タイムアウト時間を設定します。
            print(lanio.connect(address, port, timeout))
        elif num == 2:
            # LANIOのID情報を取得します。
            print(lanio.getId())
        elif num == 3:
            # LANIOのモデル情報を取得します。
            print(lanio.getModel())
        elif num == 4:
            # LANIOのDOの数を取得します。
            print(lanio.getDoNum())
        elif num == 5:
            # LANIOのDIの数を取得します。
            print(lanio.getDiNum())
        elif num == 6:
            # LANIOからモデル情報とID情報を取得します。
            devType, devId, model = lanio.requestIdModel()
            print(f'type : {devType}')
            print(f'id   : {devId}')
            print(f'model: {model}')
        elif num == 7:
            num = int(input('DO Number > '))
            state = int(input('ON(1) / OFF(0) > '))
            # LANIOのDOを設定します。
            print(lanio.outPio(num, state != 0))
        elif num == 8:
            stateList = []
            for do in range(lanio.getDoNum()):
                stateList.append(int(input('ON(1) / OFF(0) > ')) != 0)
            # LANIOのDOを複数まとめて設定します。
            print(lanio.outPioAll(stateList))
        elif num == 9:
            num = int(input('DI Number > '))
            # LANIOからDIを取得します。
            print(lanio.inPio(num))
        elif num == 10:
            # LANIOからDIをすべて取得します。
            print(lanio.inPioAll())
        elif num == 11:
            num = int(input('DO Number > '))
            # LANIOからDOの状態を取得します。
            print(lanio.getOut(num))
        elif num == 12:
            # LANIOからDOの状態をすべて取得します。
            print(lanio.getOutAll())
    except (ValueError, laniopy.LanioError) as e:
        print(e.args)
