import enum


class LanioErrorType(enum.Enum):
    '''
        LANIO エラーコード
    '''
    # 接続先がLANIOではありません。
    NOLANIO = 1
    # 接続されていません。
    NOCONNECTED = 2
    # すでに接続しています。
    ALREADYCONNECTED = 3
    # 指定された操作は実行できません。
    INVALIDOPERATION = 4
    # 不正な戻り値が返りました。
    INVALIDRETURNVALUE = 5
    # 送受信がタイムアウトしました。
    TIMEOUT = 6


class LanioError(Exception):
    '''
        LanioErrorType例外
    '''
    pass
