import enum


class LanioAiRange(enum.Enum):
    '''
        アナログ入力モデルの入力レンジの定義
    '''
    RANGE_100MV = 0
    RANGE_1V = 1
    RANGE_10V = 2
    RANGE_30V = 3
    RANGE_20MA_250OHM = 4
    RANGE_20MA_50OHM = 5
    RANGE_TC = 6  # 熱電対


class LanioAiTcType(enum.Enum):
    '''
        アナログ入力モデルの熱電対タイプ定義
    '''
    K = 0
    J = 1
    T = 2
    E = 3
    N = 4
    R = 5
    S = 6
    B = 7


class LanioAiAdcSps(enum.Enum):
    '''
        アナログ入力モデル内蔵ADCサンプリング速度の定義
    '''
    ADCSPS_10 = 0     # 10sps
    ADCSPS_16_6 = 1   # 16.6sps
    ADCSPS_50 = 2     # 50sps
    ADCSPS_60 = 3     # 60sps
    ADCSPS_400 = 4    # 400sps
    ADCSPS_1200 = 5   # 1200sps
    ADCSPS_3600 = 6   # 3600sps
    ADCSPS_14400 = 7  # 14400sps


class LanioAiTransmitCycle(enum.Enum):
    '''
        アナログ入力モデル専用の周期転送時間の定義
    '''
    CYCLE_50MSEC = 0
    CYCLE_100MSEC = 1
    CYCLE_200MSEC = 2
    CYCLE_500MSEC = 3
    CYCLE_1SEC = 4
    CYCLE_2SEC = 5
    CYCLE_5SEC = 6
    CYCLE_10SEC = 7
    CYCLE_20SEC = 8
    CYCLE_30SEC = 9
    CYCLE_1MIN = 10
    CYCLE_2MIN = 11
    CYCLE_5MIN = 12
    CYCLE_10MIN = 13


class LanioAoRange(enum.Enum):
    '''
        アナログ出力モデルの出力レンジの定義
    '''
    RANGE_10V = 0
    RANGE_20MA = 1


class LanioTcTransmitRange(enum.Enum):
    '''
        アナログモデルを対向で使用して温度伝送を行う際の出力レンジ定義
    '''
    RANGE_0_10V = 0   # 0-10 V
    RANGE_0_5V = 1    # 0-5 V
    RANGE_1_5V = 2    # 1-5 V
    RANGE_4_20MA = 3  # 4-20 MA
